Program Percol3D;

uses
 SysUtils, Types, Graphics, Windows;

const
 N_of_Exp=500;
 N=50;
 d=1;

type
  TXYZ=record
   X,Y,Z:Integer
  end;

  TFlush=array[0..N*N*N] of TXYZ;

  TArea=array[0..N+1,0..N+1,0..N+1] of ShortInt;

  TResult=record
   Result:Boolean;
   q     :Single
  end;

  TResults=array[1..N_of_Exp] of TResult;

var
  Canvas   : TCanvas;
  ScreenDC : HDC;
  Flush    : TFlush;
  nFlush1,
  nFlush2  : DWord;
  Area     : TArea;
  Results  : TResults;
  nResults : DWord;
  IsAdd    : Boolean;
  q        : Single;

procedure AddFlush(const i,j,k:Integer);
begin
 Area[i,j,k]:=1;
 Flush[nFlush1].X:=i;
 Flush[nFlush1].Y:=j;
 Flush[nFlush1].Z:=k;
 Inc(nFlush1);
 IsAdd:=True;
end;

procedure InitArea(const n0:Single);
var
 i,j,k,k1,l:Integer;
begin
 {Creating the area}
 k1:=Round(n0*N*N*N);
 for i:=0 to N+1 do
  for j:=0 to N+1 do
   for k:=0 to N+1 do
    Area[i,j,k]:=0;
 for i:=0 to N+1 do
  for j:=0 to N+1 do
  begin
   Area[i,j,0]:=-1;
   Area[i,j,N+1]:=-1;
  end;
 for j:=0 to N+1 do
  for k:=0 to N+1 do
  begin
   Area[0,j,k]:=-1;
   Area[N+1,j,k]:=-1;
  end;
 for i:=0 to N+1 do
  for k:=0 to N+1 do
  begin
   Area[i,0,k]:=-1;
   Area[i,N+1,k]:=-1;
  end;
 for l:=1 to k1 do
 begin
  repeat
   i:=Random(N)+1;
   j:=Random(N)+1;
   k:=Random(N)+1
  until Area[i,j,k]=0; 
  Area[i,j,k]:=-1;
 end;
 {Creating the flow thread}
 nFlush1:=0; nFlush2:=0;
 for i:=1 to N do
  for j:=1 to N do
   if Area[i,j,1]=0 then
    AddFlush(i,j,1);
end;

function CheckResult:Boolean;
var
 i,j:Integer;
begin
 CheckResult:=False;
 for i:=1 to N do
  for j:=1 to N do
   if Area[i,j,N]=1 then
    CheckResult:=True;
end;

procedure InitExperiment;
begin
 q:=0.65 + 0.1*Random;
 InitArea(q);
end;

procedure DoStep;
var
 k,k1:DWord;
begin
 IsAdd:=False; k1:=nFlush2;
 for k:=nFlush2 to nFlush1-1 do
 begin
  if Area[Flush[k].X-1,Flush[k].Y,Flush[k].Z] = 0 then
   AddFlush(Flush[k].X-1,Flush[k].Y,Flush[k].Z);

  if Area[Flush[k].X+1,Flush[k].Y,Flush[k].Z] = 0 then
   AddFlush(Flush[k].X+1,Flush[k].Y,Flush[k].Z);

  if Area[Flush[k].X,Flush[k].Y-1,Flush[k].Z] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y-1,Flush[k].Z);

  if Area[Flush[k].X,Flush[k].Y+1,Flush[k].Z] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y+1,Flush[k].Z);

  if Area[Flush[k].X,Flush[k].Y,Flush[k].Z-1] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y,Flush[k].Z-1);

  if Area[Flush[k].X,Flush[k].Y,Flush[k].Z+1] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y,Flush[k].Z+1);

  if not IsAdd then
   k1:=k;

 end;
 nFlush2:=k1;
end;

function DispatchExperiment:Boolean;
begin
 {If nothing can be added}
 if not IsAdd then
 begin
  {Saving the result}
  Results[nResults].Result:=CheckResult;
  Results[nResults].q:=q;
  Inc(nResults);
 end;
 DispatchExperiment:=not IsAdd;
end;

procedure StopExperiments;
var
 i:Integer;
 F:File of TResult;
begin
 {Saving the results}
 AssignFile(F,'Results.dat');
 Rewrite(F);
 for i:=1 to nResults-1 do
  Write(F,Results[i]);
 CloseFile(F);
end;

procedure HookDC;
begin
 ScreenDC:=GetDC(0);
 Canvas:=TCanvas.Create;
 Canvas.Handle:=ScreenDC;
end;

procedure UnHookDC;
begin
 ReleaseDC(0,ScreenDC);
 Canvas.Free;
end;

begin
 HookDC;
 nResults:=1;
 Randomize;
 InitExperiment;
 while nResults<N_of_Exp do
 begin
  InitExperiment;
  repeat
   DoStep
  until DispatchExperiment;
  Canvas.TextOut(200,200,IntToStr(nResults)+' experiments');
 end;
 StopExperiments;
 Canvas.TextOut(300,300,'File with the results has been already written');
 UnHookDC;
end.

