unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

const
 N=500;
 d=1;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TXY=record
   X,Y:Integer
  end;

  TFlush=array[0..N*N] of TXY;

  TArea=array[0..N+1,0..N+1] of ShortInt;

  TResult=record
   Result:Boolean;
   q     :Single
  end;

  TResults=array[1..10*N] of TResult;

var
  Form1    : TForm1;
  Flush    : TFlush;
  nFlush1,
  nFlush2  : DWord;
  Area     : TArea;
  Results  : TResults;
  nResults : DWord;
  IsAdd    : Boolean;
  q        : Single;

procedure InitArea(const n0:Single);
procedure DrawArea;
procedure DrawFlush(const i,j:Integer);
procedure AddFlush(const i,j:Integer);
function  CheckResult:Boolean;




implementation

{$R *.dfm}

procedure InitArea;
var
 i,j,k,l:Integer;
begin
 {Creating the area}
 k:=Round(n0*N*N);
 for i:=0 to N+1 do
  for j:=0 to N+1 do
   Area[i,j]:=0;
 for i:=0 to N+1 do
 begin
  Area[i,0]:=-1;
  Area[i,N+1]:=-1;
 end;
 for j:=0 to N+1 do
 begin
  Area[0,j]:=-1;
  Area[N+1,j]:=-1;
 end;
 for l:=1 to k do
 begin
  repeat
   i:=Random(N)+1;
   j:=Random(N)+1
  until Area[i,j]=0; 
  Area[i,j]:=-1;
 end;
 {Making the form}
 Form1.ClientHeight:=d*(N+2);
 Form1.ClientWidth:=d*(N+2);
 Form1.Color:=clWhite; 
 {Creating the flow thread}
 Form1.Canvas.Brush.Color:=clGreen;
 nFlush1:=0; nFlush2:=0;
 for i:=1 to N do
  if Area[i,1]=0 then
   AddFlush(i,1);
end;

procedure DrawArea;
var
 i,j:Integer;
 aRect:TRect;
begin
 Form1.Canvas.Brush.Color:=clWhite;
 aRect:=Rect(0,0,Form1.ClientWidth,Form1.ClientHeight);
 Form1.Canvas.FillRect(aRect);
 Form1.Canvas.Brush.Color:=clRed;
 for i:=0 to N+1 do
  for j:=0 to N+1 do
   if Area[i,j]=-1 then
   begin
    aRect:=Rect(d*i,d*j,d*i+d,d*j+d);
    Form1.Canvas.FillRect(aRect);
   end;
end;

procedure AddFlush;
begin
 Area[i,j]:=1;
 DrawFlush(i,j);
 Flush[nFlush1].X:=i;
 Flush[nFlush1].Y:=j;
 Inc(nFlush1);
 IsAdd:=True;
end;

procedure DrawFlush;
var
 aRect:TRect;
begin
 aRect:=Rect(d*i,d*j,d*i+d,d*j+d);
 Form1.Canvas.FillRect(aRect);
end;

function CheckResult;
var
 i:Integer;
begin
 CheckResult:=False;
 for i:=1 to N do
  if Area[i,N]=1 then
   CheckResult:=True;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
 Randomize;
 q:=Random;
 InitArea(q);
 DrawArea;
 Canvas.Brush.Color:=clGreen;
 Timer1.Enabled:=True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 k,k1:DWord;
begin
 IsAdd:=False; k1:=nFlush2;
 for k:=nFlush2 to nFlush1-1 do
 begin
  if Area[Flush[k].X-1,Flush[k].Y] = 0 then
   AddFlush(Flush[k].X-1,Flush[k].Y);

  if Area[Flush[k].X+1,Flush[k].Y] = 0 then
   AddFlush(Flush[k].X+1,Flush[k].Y);

  if Area[Flush[k].X,Flush[k].Y-1] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y-1);

  if Area[Flush[k].X,Flush[k].Y+1] = 0 then
   AddFlush(Flush[k].X,Flush[k].Y+1);
  if not IsAdd then
   k1:=k;
 end;
 nFlush2:=k1;
 {If nothing can be added}
 if not IsAdd then
 begin
  {Saving the result}
  Results[nResults].Result:=CheckResult;
  Results[nResults].q:=q;
  Inc(nResults);
  Form1.Caption:='Number of experiments ' + IntToStr(nResults-1);
  Form1.FormClick(Self);
 end;
end;

procedure TForm1.FormDblClick(Sender: TObject);
var
 i:Integer;
 Av_q:Single;
 F:File of TResult;
begin
 Timer1.Enabled:=False;
 Av_q:=0;
 for i:=1 to nResults-1 do
  if Results[i].Result then
   Av_q:=Av_q + Results[i].q;
 Av_q:=Av_q/(nResults-1);
 {Saving the results}
 AssignFile(F,'Results.dat');
 Rewrite(F);
 for i:=1 to nResults-1 do
  Write(F,Results[i]);
 CloseFile(F);
 Canvas.TextOut(100,100,'Average concentration is ' + FloatToStr(Av_q));
end;

initialization
begin
 nResults:=1;
end;

end.
